"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const redaxios_1 = __importDefault(require("redaxios"));
const request_1 = require("./request");
const logging_1 = require("../logging");
const errors_1 = require("../model/errors");
class Identify {
    constructor(configuration) {
        this.url = `${configuration.values().identifyEndpoint}/identity/token`;
        this.apiKey = configuration.apiKey;
        this.accessToken = configuration.accessToken;
        this.autoRenew = configuration.autoRenew;
    }
    setUrl(url) {
        this.url = url;
    }
    setToken(accessToken) {
        this.autoRenew = false;
        this.accessToken = accessToken;
    }
    getToken() {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                logging_1.log.info('Requestiong access token...');
                const json = {};
                const result = yield redaxios_1.default.post(this.url, json, {
                    headers: (0, request_1.headers)(this.apiKey || ''),
                });
                this.accessToken = result.data.token;
                return result.data.token;
            }
            catch (err) { // eslint-disable-line
                if (!this.apiKey) {
                    logging_1.log.error('API KEY not set, use sea.config.setApiKey');
                }
                else {
                    this.accessToken = undefined;
                    logging_1.log.error("ERRRROR" + err);
                    logging_1.log.error(`Request access token exception with code ${(_a = err === null || err === void 0 ? void 0 : err.response) === null || _a === void 0 ? void 0 : _a.status}, error ${err === null || err === void 0 ? void 0 : err.data}`);
                }
                throw new errors_1.HTTPError((_b = err === null || err === void 0 ? void 0 : err.response) === null || _b === void 0 ? void 0 : _b.status, err.data);
            }
        });
    }
    renewToken() {
        return __awaiter(this, void 0, void 0, function* () {
            this.accessToken = yield this.getToken();
            return this.accessToken;
        });
    }
}
exports.default = Identify;
